/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBGL)

#include "JSEXTBlendFuncExtended.h"

#include "ActiveDOMObject.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "JSDOMBinding.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include "WebCoreOpaqueRootInlines.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

class JSEXTBlendFuncExtendedPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSEXTBlendFuncExtendedPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSEXTBlendFuncExtendedPrototype* ptr = new (NotNull, JSC::allocateCell<JSEXTBlendFuncExtendedPrototype>(vm)) JSEXTBlendFuncExtendedPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSEXTBlendFuncExtendedPrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSEXTBlendFuncExtendedPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSEXTBlendFuncExtendedPrototype, JSEXTBlendFuncExtendedPrototype::Base);

/* Hash table for prototype */

static const HashTableValue JSEXTBlendFuncExtendedPrototypeTableValues[] =
{
    { "SRC1_COLOR_EXT"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x88F9 } },
    { "SRC1_ALPHA_EXT"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x8589 } },
    { "ONE_MINUS_SRC1_COLOR_EXT"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x88FA } },
    { "ONE_MINUS_SRC1_ALPHA_EXT"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x88FB } },
    { "MAX_DUAL_SOURCE_DRAW_BUFFERS_EXT"_s, PropertyAttribute::ReadOnly | PropertyAttribute::DontDelete | PropertyAttribute::ConstantInteger, NoIntrinsic, { HashTableValue::ConstantType, 0x88FC } },
};

const ClassInfo JSEXTBlendFuncExtendedPrototype::s_info = { "EXTBlendFuncExtended"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSEXTBlendFuncExtendedPrototype) };

void JSEXTBlendFuncExtendedPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSEXTBlendFuncExtended::info(), JSEXTBlendFuncExtendedPrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSEXTBlendFuncExtended::s_info = { "EXTBlendFuncExtended"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSEXTBlendFuncExtended) };

JSEXTBlendFuncExtended::JSEXTBlendFuncExtended(Structure* structure, JSDOMGlobalObject& globalObject, Ref<EXTBlendFuncExtended>&& impl)
    : JSDOMWrapper<EXTBlendFuncExtended>(structure, globalObject, WTFMove(impl))
{
}

static_assert(!std::is_base_of<ActiveDOMObject, EXTBlendFuncExtended>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSObject* JSEXTBlendFuncExtended::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    auto* structure = JSEXTBlendFuncExtendedPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype());
    structure->setMayBePrototype(true);
    return JSEXTBlendFuncExtendedPrototype::create(vm, &globalObject, structure);
}

JSObject* JSEXTBlendFuncExtended::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSEXTBlendFuncExtended>(vm, globalObject);
}

void JSEXTBlendFuncExtended::destroy(JSC::JSCell* cell)
{
    JSEXTBlendFuncExtended* thisObject = static_cast<JSEXTBlendFuncExtended*>(cell);
    thisObject->JSEXTBlendFuncExtended::~JSEXTBlendFuncExtended();
}

JSC::GCClient::IsoSubspace* JSEXTBlendFuncExtended::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSEXTBlendFuncExtended, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForEXTBlendFuncExtended.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForEXTBlendFuncExtended = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForEXTBlendFuncExtended.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForEXTBlendFuncExtended = std::forward<decltype(space)>(space); }
    );
}

void JSEXTBlendFuncExtended::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSEXTBlendFuncExtended*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url "_s + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSEXTBlendFuncExtendedOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, const char** reason)
{
    auto* jsEXTBlendFuncExtended = jsCast<JSEXTBlendFuncExtended*>(handle.slot()->asCell());
    auto& owner = jsEXTBlendFuncExtended->wrapped();
    if (UNLIKELY(reason))
        *reason = "Reachable from jsEXTBlendFuncExtended";
    return containsWebCoreOpaqueRoot(visitor, owner);
}

void JSEXTBlendFuncExtendedOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsEXTBlendFuncExtended = static_cast<JSEXTBlendFuncExtended*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsEXTBlendFuncExtended->wrapped(), jsEXTBlendFuncExtended);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7EXTBlendFuncExtended@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore20EXTBlendFuncExtendedE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<EXTBlendFuncExtended>&& impl)
{

    if constexpr (std::is_polymorphic_v<EXTBlendFuncExtended>) {
#if ENABLE(BINDING_INTEGRITY)
        const void* actualVTablePointer = getVTablePointer(impl.ptr());
#if PLATFORM(WIN)
        void* expectedVTablePointer = __identifier("??_7EXTBlendFuncExtended@WebCore@@6B@");
#else
        void* expectedVTablePointer = &_ZTVN7WebCore20EXTBlendFuncExtendedE[2];
#endif

        // If you hit this assertion you either have a use after free bug, or
        // EXTBlendFuncExtended has subclasses. If EXTBlendFuncExtended has subclasses that get passed
        // to toJS() we currently require EXTBlendFuncExtended you to opt out of binding hardening
        // by adding the SkipVTableValidation attribute to the interface IDL definition
        RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    }
    return createWrapper<EXTBlendFuncExtended>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, EXTBlendFuncExtended& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

EXTBlendFuncExtended* JSEXTBlendFuncExtended::toWrapped(JSC::VM&, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSEXTBlendFuncExtended*>(value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(WEBGL)
